
Titanium.UI.setBackgroundColor('white');

Ti.include('common/global.js');

Ti.App.ingrs = ingrs;
ingrs.homeWindow = [];

/* create login window first */
var loginWin=ingrs.auth.createLoginWindow();

/*loginWin.orientationModes = [
     Titanium.UI.PORTRAIT,
     Titanium.UI.LANDSCAPE_LEFT,
     Titanium.UI.LANDSCAPE_RIGHT
 ];*/

/* create main tab group var placeholder */
/*var mainTabGroup=ingrs.UI.createBaseTabGroup();*/


/* open login window */
loginWin.open();

/* Event Listeners for tabGroup */
ingrs.UI.mainTabGroup = [];
ingrs.UI.troTabGroup = [];
ingrs.UI.viewObjects = [];
Ti.App.addEventListener('launchPWEB', function(event){  
	//alert("Hi")
	Titanium.API.debug("ids "+event.planId+event.cssessionId);
	ingrs.UI.createApplicationTabGroup(event.planId,event.cssessionId);
	
	Ti.App.addEventListener('mainTabGroupOpened',function(e){
		if(ingrs.isIphone()) {
			loginWin.close();
		}
	});
	
});

Ti.App.addEventListener('launchTRO', function(event){
	Titanium.API.debug("ids "+event.planId+" planType:"+event.planType+event.footer);
	ingrs.UI.createTROTabGroup({_planId:event.planId,cssessionId:event.cssessionId,_planType:event.planType,_footer:event.footer});
});

/*Creating tabgroups for SMA/ING Access plans */
Ti.App.addEventListener('launchMore', function(event){  
	Titanium.API.debug("ids "+event.planId+" planType:"+event.planType+event.footer+event.titleName+event.headerType);
	ingrs.UI.createMoreTabGroup({_planId:event.planId,cssessionId:event.cssessionId,_planType:event.planType,_footer:event.footer,_titleName:event.titleName,_header:event.headerType});
});

Ti.App.addEventListener('hideTabGroup', function(event){
	if(typeof Ti.API._activeTabGroup !== 'undefined') {
		if (ingrs.isIphone()){
		 	Ti.API._activeTabGroup.animate({bottom:-60});
		}
		else{
			Ti.API._activeTabGroup.animate({top:-60});
		}
	}
});
Ti.App.addEventListener('showTabGroup', function(event){ 
	if(typeof Ti.API._activeTabGroup !== 'undefined') {
		if (ingrs.isIphone()){
			Ti.API._activeTabGroup.animate({bottom:0});
		}
		else {
			Ti.API._activeTabGroup.animate({top:0});
		}
	}
});



Ti.App.addEventListener('app:eventLogoutClicked', function(event){
	
			Ti.App.fireEvent('app:endSession');
			ingrs.UI.logout();
	
});

Ti.App.addEventListener('eventOpenTabGroupBM', function(event)  
{
	/* create fresh balances + more tabgroup */
	ingrs.UI.tabGroupBM=ingrs.UI.createApplicationTabGroupCustom(1,0,0,1); /* 10001 = benefits tab + more tab */
	ingrs.UI.tabGroupBM.open();
});

Ti.App.addEventListener('eventCloseTabGroupBM', function(event)  
{
	tabGroupBM.close();
});


/* Event listeners for buttons */
Ti.App.addEventListener('eventHomeButtonClicked', function(event)  
{
	alert('Home button clicked');
});

/*  Event Listeners for application events */
Ti.App.addEventListener('pause', function(event)  
{  
	Ti.API.info('app.js: Pause event on '+Ti.Platform.osname);
	if (ingrs.isIphone()){
		var snapFolder = Ti.Filesystem.getFile(Ti.Filesystem.applicationSupportDirectory,"../Caches/Snapshots"); 
		snapFolder.deleteDirectory(true); 
		snapFolder.write("No Folder for you!"); 
	}
});
Ti.App.addEventListener('resume', function(event)  
{  
	Ti.API.info('app.js: Resume event on '+Ti.Platform.osname);
});
Ti.App.addEventListener('closed', function(event)  
{  
	Ti.API.info('app.js: Closed event on '+Ti.Platform.osname);
});

/* ------------------------------------------------------------------------------------------------------------ */
