// this sets the background color of the master UIView (when there are no windows/tab groups on it)
Titanium.UI.setBackgroundColor('#000');

// create tab group
var tabGroup = Titanium.UI.createTabGroup();


//
// create base UI tab and root window
//
var win1 = Titanium.UI.createWindow({  
    title:'Tab 1',
    backgroundColor:'#fff'
});
var tab1 = Titanium.UI.createTab({  
    icon:'KS_nav_views.png',
    title:'Tab 1',
    window:win1
});

var label1 = Titanium.UI.createLabel({
	color:'#999',
	text:'I am Window 1',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win1.add(label1);

var view = Ti.UI.createView({
			height:60,
			right:'3.1%',
			left:'3.1%',
			scrollable:false,
			backgroundColor:'white',
			top:60,
			borderRadius:10,
			borderWidth:1,
			borderColor:'#808080',
			layout:'vertical'
		});

	
	var rowView = Ti.UI.createView({
				height:'auto'
			});

			var l = Ti.UI.createLabel({
				left:'3.1%',
				right:0,
				font: {
					fontSize:17,
					fontWeight:'bold'
				},
				color:'#000000',
				height:44,
				text:'appcelerator'
			});
			rowView.add(l);
			view.add(rowView)
			win1.add(view);
			view.addEventListener('click', function(e) {
				alert(e.source)
			});
//
// create controls tab and root window
//
var win2 = Titanium.UI.createWindow({  
    title:'Tab 2',
    backgroundColor:'#fff'
});
var tab2 = Titanium.UI.createTab({  
    icon:'KS_nav_ui.png',
    title:'Tab 2',
    window:win2
});

var label2 = Titanium.UI.createLabel({
	color:'#999',
	text:'I am Window 2',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto'
});

win2.add(label2);



//
//  add tabs
//
tabGroup.addTab(tab1);  
tabGroup.addTab(tab2);  


// open tab group
tabGroup.open();
