/**
 * Styles for Balances Summary Page
 */

var styles= {
	
	/* Usage
	 * 
	 * var labelTitle = Titanium.UI.createLabel(styles.SubheaderTitle);
	 * 
	 * var labelTitle1 = Titanium.UI.createLabel({
			top : 40,
			left : '6%',
			width : '90%',
			height : '40',
			font : styles.SubheaderTitle.font,
			color : styles.SubheaderTitle.color
		});
	 */
	SubheaderTitle: {
		font: {
			fontFamily:'Helvetica Neue',
			fontSize:18,
			fontWeight:'bold'
		},
		color:'#363636',
		top : 15,
		left : '3.1%',
		textAlign : 'left',
		width : 'auto',
		height : '35',
	},
	BoldText: {
		font: {
			fontFamily:'Helvetica Neue',
			fontSize:15,
			fontWeight:'bold'
		},
		top:15,
		left:'3.5%',
		textAlign:'left',
		width:'90%',
	//	height:'auto',
		height:60,
		color:'#363636'
	},
	SummaryText: {
		font: {
			fontFamily:'Helvetica Neue',
			fontSize:14
		},
		top:15,
		left:'3.1%',
		right:'3.1%',
		textAlign:'left',
		height:'auto',
		color:'#363636'
	},
	SummaryText_Bullet: {
		font: {
			fontFamily:'Helvetica Neue',
			fontSize:13
		},
		top:10,
		left:'7%',
		width:'88%',
		height:'auto',
		color:'#363636'
	},
	Bullet: {
		font: {
			fontFamily:'Helvetica Neue',
			fontSize:13
		},
		top:10,
		left:'4.0%',
		width:'2%',
		height:'auto',
		color:'#363636'
	},
	StandardTextField: {
		right:'3.1%',
		left:'3.1%',
		borderStyle:Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
		height:44,
		top:5,
		backgroundColor: 'white',
		borderRadius: 5,
		font:{fontSize:17,fontFamily:'Helvetica Neue'},
		returnKeyType:Titanium.UI.RETURNKEY_DONE
	},
	ButtonOrange: {
		left:'3.1%',
		right:'3.1%',
		top:20,
		height:41,
		font:{fontSize:19,fontWeight:'bold',fontFamily:'Helvetica Neue'},
		color:'#fff',
		backgroundImage:'/images/btns/btn_off.png',
		backgroundSelectedImage:'/images/btns/btn_on.png'
	},
	/*Label for Year*/
	Label: {
		font: {
			fontFamily:'Helvetica Neue',
			fontSize:11.5,
			fontWeight:'bold'

		},
		left:'0%',
		color:'#363636',
		width:'auto',
		height:'auto'
	},
	/*Label for Balance*/
	LabelValue: {
		font: {
			fontFamily:'Helvetica Neue',
			fontSize:11.5,
			fontWeight:'bold'

		},

		left:'2.5%',
		color:'#ffffff',
		width:'auto',
		height:'auto'
	},
	mainView: {
		left:0,
		right:0,
		width:'100%',
		top:5,
		height:25,

	},
	/*Diagonal Grey Background for Graph*/
	ViewBackground: {
		top:0,
		left:0,
		width:'76%',
		backgroundImage:'/images/bodycontent/bar_chart_diagonal_pattern.png',
		height:25,
		right:'3.1%',
		left:'25%'
	},
	/*Right Arrow Image for PRR and Monthly Income for iOS platform*/
	rightArrowImage: {
		top:20,
		backgroundImage:'/images/arrows/arrow_table_cell_sm.png',
		width:7,
		height:10,
		right:0

	},
	/*Right Arrow Image for PRR and Monthly Income for Android platform*/
	rightArrowImageAndroid: {
		top:15,
		backgroundImage:'/images/arrows/arrow_table_cell_sm_android.png',
		width:22,
		height:21,
		right:'4%'

	},
	/*Nav Right Button stlyle - Logout and Home Button */
	navRightBtn: {
		width:50,
			height:30,
			top:5,
			right:'1.5%',
			borderRadius:4,
			font: {
				fontSize:12,
				fontWeight:'bold',
				fontFamily:'Helvetica Neue'
			},
			borderColor: '#B03F02'
	},
	/* Division line in footer */
	divline: {
		top:50,
		backgroundImage:'/images/bodycontent/div_line_horizontal.png',
		left:0,
		right:0,
		height:2
		//width:'100%'
	}
};

