(function() {

	var homeTab, balancesTab, contributionsTab, investmentsTab, moreTab, moreTabDB, benefitsTab, activityIndicator,actTab=null;
	/*
	 * create tabs
	 */
	if(ingrs.platform.osname !== "android") {
		createHomeTab = function() {
			homeTab = Titanium.UI.createTab({
				icon : 'images/icons/icon_monthly_income_off.png',
				title : L('Label_Home')
			});
			return homeTab;
		}
		createBalancesTab = function() {
			balancesTab = Titanium.UI.createTab({
				icon : 'images/menu/white/menu_balance_icon.png',
				title : L('Label_Balances')
			});
			return balancesTab;
		}
		createContributionsTab = function() {
			contributionsTab = Titanium.UI.createTab({
				icon : 'images/menu/white/menu_contributions_icon.png',
				title : L('Label_Contributions')
			});
			return contributionsTab;
		}
		createInvestmentsTab = function() {
			investmentsTab = Titanium.UI.createTab({
				icon : 'images/menu/white/menu_investments_icon.png',
				title : L('Label_Investments')
			});
			return investmentsTab;
		}
		createMoreTab = function() {
			moreTab = Titanium.UI.createTab({
				icon : 'images/menu/white/menu_more_icon.png',
				title : L('Label_More')
			});
			return moreTab;
		}
		createMoreTabDB = function() {
			moreTabDB = Titanium.UI.createTab({
				icon : 'images/menu/white/menu_more_icon.png',
				title : L('Label_More')
			});
			return moreTabDB;
		}
		createBenefitsTab = function() {
			benefitsTab = Titanium.UI.createTab({
				icon : 'images/menu/white/menu_benefits.png',
				title : L('Label_Benefits')
			});
			return benefitsTab;
		}
	} else {
		createHomeTab = function() {
			homeTab = Titanium.UI.createTab({
				icon : 'images/icons/menu_balance_icon.png',

			});
			return homeTab;
		}
		createBalancesTab = function() {
			balancesTab = Titanium.UI.createTab({
				icon : 'images/menu/android/menu_balance_icon.png',

			});
			return balancesTab;
		}
		createContributionsTab = function() {
			contributionsTab = Titanium.UI.createTab({
				icon : 'images/icons/icon_monthly_income_on.png',

			});
			return contributionsTab;
		}
		createInvestmentsTab = function() {
			investmentsTab = Titanium.UI.createTab({
				icon : 'images/menu/android/menu_investments_icon.png',

			});
			return investmentsTab;
		}
		createMoreTab = function() {
			moreTab = Titanium.UI.createTab({
				icon : 'images/menu/android/menu_more_icon.png',

			});
			return moreTab;
		}
		createMoreTabDB = function() {
			moreTabDB = Titanium.UI.createTab({
				icon : 'images/menu/android/dbplans/menu_more_icon.png',

			});
			return moreTabDB;
		}
		createBenefitsTab = function() {
			benefitsTab = Titanium.UI.createTab({
				icon : 'images/menu/android/dbplans/menu_benefits_icon.png',

			});
			return benefitsTab;
		}
	}

	var sessionId, planId, contribDisplayFlag;
	ingrs.UI.createBaseTabGroup = function() {
		/* create main tab group */
		var tabGroup = Titanium.UI.createTabGroup({
			exitOnClose : 'false'
		});
		return tabGroup;
	};
	ingrs.UI.createApplicationTabGroup = function(_planId, _cssessionId) {
		ingrs.UI.backButtonFocus=false;
		function createApplicationTabGroupInternal(_planId, _cssessionId) {
			/* create main tab group */
			sessionId = _cssessionId;
			planId = _planId;
			var tabGroup = Titanium.UI.createTabGroup({
				exitOnClose : 'false'
			});
			ingrs.UI.viewObjects[_planId] = {};
			ingrs.UI.viewObjects[_planId].tabGroup = tabGroup;
			Ti.API.activePlan = _planId;
			ingrs.UI.viewObjects[_planId].isContribHistUpdated = false;
			ingrs.UI.backHandler = new ingrs.UI.GenricTabHandler(tabGroup);
			tabGroup.barColor = '#ff7b01';
			/* add 4 tabs */
			homeTab = createHomeTab();
			tabGroup.addTab(homeTab);
			homeTab.isHome = true;
			homeTab.window = Ti.UI.createWindow({});
			var balancesTabL = createBalancesTab();
			tabGroup.addTab(balancesTabL);
			balancesTabL.isBalances = true;
			/* recreate tabwindow */
	
			/* Object to be passed */
	
			var params = {
				sessionId : sessionId,
				planId : planId,
				pageId : L('Label_Balance_Summary_Page'),
				planType : 'DC'
			};
			Titanium.API.debug("Params::********" + params);
			Ti.API._activeTabGroup = tabGroup;
			var moreTabL = createMoreTab();
				
			var response={"asOfDate":"OCT 24, 2011","balBySourceFlag":"Y","balanceHistoryDataList":[{"balance":"$0","percent":"0","year":"2005"},{"balance":"$40,330","percent":"13","year":"2006"},{"balance":"$54,501","percent":"17","year":"2007"},{"balance":"$69,309","percent":"22","year":"2008"},{"balance":"$79,249","percent":"25","year":"01\/01\/2011"},{"balance":"$73,506","percent":"23","year":"10\/23\/2011"}],"brandName":null,"contribDisplayFlag":"U","currentBal":"73,506.43","displayBalanceHistoryGraph":"Y","displayBrandName":"I","investmentDisplayFlag":"N","molIncome":0.00,"monthlyIncomeDisplayFlag":"Y","personalRateofReturn":"0.00","prrDisplayFlag":"N","vestingFlag":"Y"};
			
						
						if(response != null) {
	
						//set the headerType and client name
						ingrs.globalData.company = response.brandName;
						ingrs.globalData.headerType = response.displayBrandName;
						ingrs.UI.viewObjects[_planId].contribDisplayFlag = response.contribDisplayFlag;
						ingrs.UI.viewObjects[_planId].contrHistServResponse = null;
						ingrs.UI.viewObjects[_planId].contribHistoryDisplayFlag = response.contribHistoryDisplayFlag;
						if(ingrs.UI.viewObjects[_planId].contribDisplayFlag !== 'N') {
							var contributionsTab = createContributionsTab();
							tabGroup.addTab(contributionsTab);
							contributionsTab.isContributions = true;
							contributionsTab.window = Titanium.UI.createWindow({title:'Window', barColor:'#808080'});
							//contributionsTab.window = ingrs.contributions.createContributionsWindow(ingrs.UI.viewObjects[_planId].contribDisplayFlag);
						}
						
						
						investmentsTab = createInvestmentsTab();
						//if(response.displayInvestments){
							investmentsTab.isInvestments = true;
							tabGroup.addTab(investmentsTab);
						//}
						
						tabGroup.addTab(moreTabL);

						moreTabL.isMore = true;
						balancesTabL.window = ingrs.balances.createBalancesWindow(response);
						
						ingrs.UI.viewObjects[_planId].investmentAllocResponseLoaded = false;
						
						//investmentsTab.window =ingrs.investments.createInvestmentsWindow();
						investmentsTab.window =Titanium.UI.createWindow({title:'Window', barColor:'#808080'});
							
						moreTabL.window=Titanium.UI.createWindow({title:'Window', barColor:'#808080'});
		
						
						//moreTabL.window = ingrs.more.createMoreWindow(params);
						
							tabGroup.setActiveTab(1);
							Ti.API._activeTab = balancesTabL;
							
							tabGroup.open();
						

						ingrs.UI.mainTabGroup[_planId] = tabGroup;
						Ti.App.fireEvent('mainTabGroupOpened');
	
					}
				
		
			/* add global tab tracker */
			tabGroup = ingrs.UI.addTabGroupListener(tabGroup);
			return tabGroup;
		}
		//alert('_planId: '+_planId);
		if(typeof ingrs.UI.mainTabGroup[_planId] === 'undefined' && Ti.API.activePlan !== _planId) {
			//alert(Ti.API.activePlan + ' * '+_planId);
			actTab=homeTab//null
			ingrs.UI.focusedTab=[];
			return createApplicationTabGroupInternal(_planId, _cssessionId);
		}
		else {
			//alert('else mainTabGroup');
			actTab=homeTab//null
			ingrs.UI.focusedTab=[];
			Ti.API.activePlan = _planId;
			Ti.API._activeTabGroup = ingrs.UI.mainTabGroup[_planId];
			if(ingrs.isAndroid()) {
				ingrs.UI.mainTabGroup[_planId].open();
			}
			ingrs.UI.viewObjects[_planId].contrHistServResponse = null;
			ingrs.UI.viewObjects[_planId].isContribHistUpdated = false;
			ingrs.UI.viewObjects[_planId].investmentAllocResponseLoaded = false;
			
				ingrs.UI.mainTabGroup[_planId].setActiveTab(1);
				Ti.API._activeTab = ingrs.UI.mainTabGroup[_planId].tabs[1];
				ingrs.UI.closeAllWindowsTillMainLogic(ingrs.UI.mainTabGroup[_planId].tabs[1],false);
			
			if(ingrs.isIphone()) {
				//alert('isIphone mainTabGroup');
				ingrs.UI.mainTabGroup[_planId].open();
			}
		}

	};
	/* end ingrs.UI.createApplicationTabGroup function */
	ingrs.UI.createApplicationTabGroupCustom = function(_bal, _cont, _inv, _more) {
		
		function createApplicationTabGroupCustomInternal(_bal, _cont, _inv, _more) {
			/* _bal, _cont, _inv, and _more should all be 0 or 1. 0 = skip, 1 = add */
			/* create main tab group */
			var tabGroup = Titanium.UI.createTabGroup({
				exitOnClose : 'false'
			});
			tabGroup.barColor = '#ff7b01';
			/* figure out which tabs to add */
			Ti.API._activeTabGroup = tabGroup;
			ingrs.UI.viewObjects['GLOBAL'] = {};
			ingrs.UI.viewObjects['GLOBAL'].tabGroup = tabGroup;
			Ti.API.activePlan = 'GLOBAL';
			
			if(_bal === 1) {
				var balancesTab = createBalancesTab();
				balancesTab.window = ingrs.balances.createBalancesWindow();
				balancesTab.isBalances = true;
				tabGroup.addTab(balancesTab);
			}
			if(_cont === 1) {
				ingrs.UI.viewObjects['GLOBAL'].contrHistServResponse = null;
				var contributionsTab = createContributionsTab();
				contributionsTab.window = ingrs.contributions.createContributionsWindow(ingrs.UI.viewObjects['GLOBAL'].contribDisplayFlag);
				contributionsTab.isContributions = true;
				tabGroup.addTab(contributionsTab);
			}
			if(_inv === 1) {
				var investmentsTab = createInvestmentsTab();
				investmentsTab.window = ingrs.investments.createInvestmentsWindow();
				ingrs.UI.viewObjects['GLOBAL'].investmentAllocResponseLoaded = false;
				investmentsTab.isInvestments = true;
				tabGroup.addTab(investmentsTab);
			}
			if(_more === 1) {
				var moreTab = createMoreTab();
				moreTab.window = ingrs.more.createMoreWindow(null);
				tabGroup.addTab(moreTab);
				moreTab.isMore = true;

			}
			/* add global tab tracker */
			tabGroup = ingrs.UI.addTabGroupListener(tabGroup);
	
			Ti.API._activeTab = tabGroup.activeTab;
			// rjg
			return tabGroup;
		}
		if(typeof ingrs.UI.tabGroupBM === 'undefined'){
			return createApplicationTabGroupCustomInternal(params);
		}
		else {
			ingrs.UI.viewObjects['GLOBAL'].contrHistServResponse = null;
			Ti.API._activeTabGroup = ingrs.UI.tabGroupBM;
			if(_inv === 1) {
				ingrs.UI.viewObjects['GLOBAL'].isContribHistUpdated = false;
				ingrs.UI.viewObjects['GLOBAL'].investmentAllocResponseLoaded = false;
			}
			ingrs.UI.tabGroupBM.setActiveTab(0);
			Ti.API._activeTab = ingrs.UI.tabGroupBM.tabs[0];
			ingrs.UI.closeAllWindowsTillMainLogic(ingrs.UI.tabGroupBM.tabs[0],false);
		}
	};
	/* end ingrs.UI.createApplicationTabGroupCustom function */
	ingrs.UI.addTabGroupListener = function(_tabGroup) {
		if(ingrs.isAndroid()) {
			_tabGroup.addEventListener('click', function(e) {
				ingrs.UI.closeAllWindowsTillMain(Ti.API._activeTab);
			});
		}
		
		/* this function is necesary to track current tab in Ti namespace for opening tab children */
		_tabGroup.addEventListener('focus', function(e) {
			if(ingrs.UI.backButtonFocus){
				ingrs.UI.backButtonFocus=false;/* Not adding the tab to array if the focus is triggered by back button */
			} else {
				ingrs.UI.focusedTab.push(actTab);
				if(typeof Ti.API._activeTab !== 'undefined' && Ti.API._activeTab !== null){
					if(typeof e.tab !== 'undefined' && e.tab !== null){
						ingrs.UI.closeAllWindowsTillMain(Ti.API._activeTab);/* Closing all the windows when the tab loses focus */
					}
				}
			}
			var prevTab = Ti.API._activeTab;
			
			if(typeof e.tab === 'undefined' || e.tab === null) {
				return;
			}
			actTab = e.tab;
			Ti.API._activeTabGroup = _tabGroup;
			for(var i in ingrs.UI.viewObjects) {
				if(ingrs.UI.viewObjects[i].tabGroup === _tabGroup) {
					Ti.API.activePlan = i;
					break;
				}
			}
			_tabGroup._activeTab = e.tab;
			_tabGroup._activeTabIndex = e.index;
			/* create property in Ti namespace */
			Ti.API._activeTab = _tabGroup._activeTab;
			if(_tabGroup._activeTabIndex === -1) {
				return;
			} else if(_tabGroup._activeTab.isContributions === true) {/*If the tab is contributions, then make the network call and display data */
				Ti.API.debug('cont' + sessionId + '***' + planId);
				if(ingrs.UI.viewObjects[Ti.API.activePlan].contribDisplayFlag === 'H') {
					if(!ingrs.UI.viewObjects[Ti.API.activePlan].isContribHistUpdated) {
						ingrs.contributions.updateContributionHistoryWin();
						ingrs.UI.viewObjects[Ti.API.activePlan].isContribHistUpdated = true;
					}
				} else {
					//ingrs.contributions.updateContributionsWindow();
				}
			} else if(_tabGroup._activeTab.isHome === true) {/*If the tab is contributions, then make the network call and display data */
				Ti.API._activeTabGroup.close();
				ingrs.UI.acctSummaryWinHandle.open();
				if( typeof Ti.API._activeTabGroup !== 'undefined') {
					delete Ti.API._activeTabGroup;
				}
				if( typeof Ti.API._activeTab !== 'undefined') {
					Ti.API._activeTab = null;
					delete Ti.API._activeTab;
				}
				for(var i in ingrs.UI.flippableTabWins) {
					ingrs.UI.flippableTabWins[i].isActive = false;
				}

				//_tabGroup.homeTab.window.open();
				//ingrs.auth.createAcntSummaryWin(ingrs.auth.getParam()).open();

			} else if(_tabGroup._activeTab.title==="Investments") {
					//ingrs.investments.updateInvestmentDS();
			} 
		});
		return _tabGroup;

	};
	/**
	 * Function to open child windows in current tab
	 */
	ingrs.UI.openChildWindow = function(_window, _prevWindow) {

		// new handler. _prevWindow is optional. can manually set which prev window to open
		ingrs.UI.addWinToTabAndOpen(Ti.API._activeTab, _window, Ti.API._activeTabGroup, _prevWindow);

		// old:
		/*
		 if(ingrs.isAndroid()) {
		 Titanium.API.debug("Platform*****Android");
		 var currTab = Titanium.UI.currentTab;
		 ingrs.UI.backHandler.addWinToTabAndOpen(currTab, _window);

		 } else {
		 Titanium.API.debug("Platform*****iPhone");
		 var currITab = Ti.API._activeTab;
		 ingrs.UI.backHandler.addWinToTabAndOpen(currITab, _window);
		 }
		 */
	};
	ingrs.UI.createTROTabGroup = function(params) {

		function createTROTabGroupInternal(params) {
			/* create main tab group */
			var tabGroup = Titanium.UI.createTabGroup({
				exitOnClose : 'false'
			});
			tabGroup.barColor = '#ff7b01';
			ingrs.UI.viewObjects[params._planId] = {};
			ingrs.UI.viewObjects[params._planId].tabGroup = tabGroup;
			Ti.API.activePlan = params._planId;
			
			Ti.API._activeTabGroup = tabGroup;
	
			/*var data = {
			 planName:'Sun Advantage Cash Balance Plan',planSubHeader:'PlanDetails',balance:'$140,059.12',balanceText:'Account Balance', asOfDate:'JAN 1, 2011',
			 desc:'this is a shot description about the cash balance plan',planAmounts:[{key:'Qualified Plan Balance',value:'$120,059.00'},
			 {key:'Non-Qualified Plan Balance',value:'$20,059.00'}]
	
			 };
			 benefitsTab.window=ingrs.mmpension.createBenefitsWin({planDetails:data});
			 tabGroup.open();*/
			/* add tabs */
			var homeTab = createHomeTab();
			if(ingrs.isAndroid()) {
				homeTab.icon = '/images/menu/android/dbplans/menu_home_icon.png';
			}
			tabGroup.addTab(homeTab);
			homeTab.isHome = true;
	
			var benefitsTab = createBenefitsTab();
			tabGroup.addTab(benefitsTab);
			actTab=homeTab;
			ingrs.UI.focusedTab=[];
			var moreTabDB = createMoreTabDB();
			
	
			ingrs.net.httpCall({
				url : '/eportal/mobile/mmPension.action',
				data : {
					planId : params._planId,
					planType : params._planType
				},
				cb : function(response) {
					if(response != null) {
						ingrs.globalData.company = response.planData.employerName;
						ingrs.globalData.headerType = response.planData.brandHeaderType;
						tabGroup.addTab(moreTabDB);
						moreTabDB.isMore = true;
						moreTabDB.window = ingrs.more.createMoreWindow({
							sessionId : params.cssessionId,
							planId : params._planId,
							planType : params._planType,
							pageId : 'custservice'
						});
						Ti.API._activeTabGroup = tabGroup;
						benefitsTab.window = ingrs.mmpension.createBenefitsWin(response);
						homeTab.window = Ti.UI.createWindow({});
							tabGroup.setActiveTab(1);
							Ti.API._activeTab = benefitsTab;
							tabGroup.open();
						ingrs.UI.troTabGroup[params._planId] = tabGroup;
					}
				}
			});
	
			Ti.API._activeTab = tabGroup.activeTab;
			// rjg
	
			/* add global tab tracker */
			tabGroup = ingrs.UI.addTabGroupListener(tabGroup);
			Ti.App.fireEvent('mainTabGroupOpened');
			return tabGroup;
		}
		if(typeof ingrs.UI.troTabGroup[params._planId] === 'undefined' || Ti.API.activePlan !== params._planId){
			return createTROTabGroupInternal(params);
		}
		else {
			Ti.API._activeTabGroup = ingrs.UI.troTabGroup[params._planId];
			Ti.API.activePlan = params._planId;
			
			if(ingrs.isAndroid()) {
				ingrs.UI.troTabGroup[params._planId].open();
			}
				ingrs.UI.troTabGroup[params._planId].setActiveTab(1);
				ingrs.UI.troTabGroup[params._planId].setActiveTab(ingrs.UI.troTabGroup[params._planId].tabs[1]);
				Ti.API._activeTab = ingrs.UI.troTabGroup[params._planId].tabs[1];
				ingrs.UI.closeAllWindowsTillMainLogic(ingrs.UI.troTabGroup[params._planId].tabs[1],false);
			
			if(ingrs.isIphone()) {
				ingrs.UI.troTabGroup[params._planId].open();
			}
		}
	};

	ingrs.UI.createHorizontalSeparatorView = function() {
		return Ti.UI.createView({
			top : 15,
			backgroundImage : '/images/bodycontent/div_line_horizontal.png',
			left : 0,
			height : 2,
			width : '100%'
		});
	};

	ingrs.UI.createValidationNoticeDialog = function() {
		var alertDialog = Titanium.UI.createAlertDialog({
			title : L('error_validation_title'),
			message : L('error_validation_text'),
			buttonNames : [L('Alert_Invalid_Login_Btn_OK')],
			cancel : 0
		});
		return alertDialog;
	};

	ingrs.UI.errorAlertDialog = function(param) {
		var alertDialog = Titanium.UI.createAlertDialog({
			title : param.title,
			message : param.message,
			buttonNames : ['OK']
		});
		return alertDialog;
	};

	ingrs.UI.logout = function() {
		/* reset globalData on logout */
		//ingrs.globalData.resetGlobalData();
		/*var loginWin=ingrs.auth.createLoginWindow();
		 loginWin.navBarHidden=true;
		 loginWin.top=0;
		 loginWin.open();*/

		loginWin.resetWindow();
		if( typeof Ti.API._activeTab !== 'undefined' && Ti.API._activeTab !== null) {
			Ti.API._activeTabGroup.setActiveTab(1); 
			ingrs.UI.closeAllWindowsTillMain(Ti.API._activeTab);
		}
		for(var i in ingrs.UI.mainTabGroup) {
			ingrs.UI.mainTabGroup[i].close();
		}
		ingrs.UI.mainTabGroup = [];
		ingrs.UI.viewObjects = [];
		
		if( typeof ingrs.UI.moreTabGroup !== 'undefined') {
			ingrs.UI.moreTabGroup.close();
			delete ingrs.UI.moreTabGroup;
		}
		if( typeof Ti.API._activeTabGroup !== 'undefined') {
			delete Ti.API._activeTabGroup;
		}
		if( typeof Ti.API._activeTab !== 'undefined') {
			Ti.API._activeTab = null;
			delete Ti.API._activeTab;
		}
		
		for(var i in ingrs.UI.flippableTabWins) {
			ingrs.UI.flippableTabWins[i].isActive = false;
		}
		ingrs.UI.flippableTabWins = [];
		for(var i in ingrs.UI.troTabGroup) {
			ingrs.UI.troTabGroup[i].close();
		}
		ingrs.UI.troTabGroup = [];
		
		if( typeof ingrs.UI.tabGroupBM !== 'undefined') {
			ingrs.UI.tabGroupBM.close();
			delete ingrs.UI.tabGroupBM;
		}
		for(var i in ingrs.homeWindow) {
			var wi = ingrs.homeWindow[i]
			if( typeof wi !== 'undefined') {
				wi.close();
			}
		}
		if(typeof ingrs.UI.acctSummaryWinHandle !== 'undefined') {
			delete ingrs.UI.acctSummaryWinHandle;
		}
		
		if(ingrs.isIphone) {
			loginWin.open();
		}

	}
	/*******************************************************************************
	 * Self Calling Function that creates the top Subheader View for all Modules
	 * @param :  _trxTimestamp,_trxConfirmNum,_trxMsg
	 * @returns: subheader view
	 ******************************************************************************/
	ingrs.UI.createGenericReviewAndConfirmationSubHeaderView = function(_title, _msg) {

		var nonBottomLineHeight = 155;
		var bottomLineHeight = 8;
		var containerHeight = (nonBottomLineHeight + bottomLineHeight);

		var container = Titanium.UI.createView({
			layout : 'vertical',
			top : 0,
			left : 0,
			height : containerHeight
		});
		var subNavView = Titanium.UI.createView({
			top : 0,
			left : 0,
			height : containerHeight,
			backgroundColor : '#e1e1e1'
		});

		var subNavTitleView = Titanium.UI.createView({
			top : 0,
			left : 0,
			right : 0,
			layout : 'vertical',
			height : nonBottomLineHeight,
			backgroundColor : '#e1e1e1'
		});

		var subNavViewBottomLine = Titanium.UI.createView({
			top : nonBottomLineHeight,
			height : 8,
			backgroundColor : '#ff7c00'
		});

		// TITLE text.. big letters
		var subNavViewSectionTitleLabel = Titanium.UI.createLabel({
			top : 12,
			height : 'auto',
			left : '5%',
			right : '3.1%',
			color : '#363636',
			text : _title,
			shadowColor : '#ffffff',
			shadowOffset : {
				x : 1,
				y : 1
			},
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 20,
				fontWeight : 'bold'
			}
		});

		// SUB text, smaller letters
		var subNavViewSubTextLabel = Titanium.UI.createLabel({
			top : 5,
			height : 'auto',
			left : '5%',
			right : '5%',
			color : '#363636',
			text : _msg,
			shadowColor : '#ffffff',
			shadowOffset : {
				x : 1,
				y : 1
			},
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 13,
				fontWeight : 'regular'
			}
		});

		subNavTitleView.add(subNavViewSectionTitleLabel);
		subNavTitleView.add(subNavViewSubTextLabel);
		subNavView.add(subNavTitleView);
		subNavView.add(subNavViewBottomLine);
		container.add(subNavView);

		return container;

	};
	// end ingrs.UI.createGenericReviewAndConfirmationSubHeaderView

	/*
	 * Function to create a row in the module windows
	 * param : menu label and its image
	 * returns row
	 */
	ingrs.UI.createMenuRow = function(_label, _leftImage, _rightImage, _labelLeft) {

		var row = Titanium.UI.createTableViewRow({
			hasChild : true
		});
		/* create items to add to row */
		var rowLabel = Titanium.UI.createLabel({
			top : 0,
			left : '12%',
			width : 'auto',
			height : 50,
			text : _label,
			color : '#363636',
			font : {
				fontSize : 13.5,
				fontWeight : 'bold',
				fontFamily : 'Helvetica Neue'
			}
		});
		if(ingrs.isAndroid()) {
			rowLabel.left = '8%';
		}
		if( typeof _leftImage !== 'undefined' && _leftImage !== null) {
			if(ingrs.isAndroid()) {
				var view = Ti.UI.createView({
					backgroundImage:_leftImage,
					left:5,
					width:18,
					height:15
				});
				row.add(view);
			}
			else {			
				row.leftImage = _leftImage;
			}
		}
		if( typeof _rightImage !== 'undefined' && _rightImage !== null) {
			row.rightImage = _rightImage;
		}

		if( typeof _labelLeft !== 'undefined' && _labelLeft !== null) {
			rowLabel.left = _labelLeft;
		}
		row.add(rowLabel);
		row.childWin = _label;
		return row;
	}
	/*
	 * Function to create the view to display menu on click of chevron in subheader
	 */
	ingrs.UI.updateSubHeaderMenu = function(_plan, _menu, _menuImages, _menuImagesOn, _module) {
		var menuView = Titanium.UI.createView({
			top : 0,
			left : 0
		});
		var subView = Titanium.UI.createView({
			layout : 'vertical',
			top : 0,
			left : 0,
			height : 'auto'

		});
		/* Label to display Plan Information */
		var labelPlan = Titanium.UI.createLabel({

			top : 20,
			height : 60,
			left : '5%',
			width : '93.75%',
			color : '#363636',
			font : {
				fontSize : 15,
				fontWeight : 'bold',
				fontFamily : 'Helvetica Neue'
			},

			text : _plan

		});

		/* Android doesn't have a navbar at the top by default so there is a difference in top alignment on iPhone and Android */
		if(ingrs.isAndroid()) {
			labelPlan.top = 75;

		}
		subView.add(labelPlan);
		var subNavViewTopLine = Titanium.UI.createView({
			top : 12,
			height : 7,
			backgroundColor : '#ff6900'
		});
		var container = Ti.UI.createView({
			top : 0,
			left : 0,
			right : 0,

		});

		subView.add(subNavViewTopLine);

		/* Array to hold tableview rows */
		var dataSource = [];
		/* Loop that creates table view rows using above Arrays */
		for( i = 0, j = 0, len = _menu.length, imageslen = _menuImages.length; i < _menu.length, j < imageslen; i++, j++) {
			if(_module === L('Label_More')) {
				var rowLabel = Titanium.UI.createLabel({
					left : '14%',
					height : 37,
					color : '#363636',
					text : _menu[i],
					font : {
						fontSize : 13,
						fontWeight : 'bold',
						fontFamily : 'Helvetica Neue'

					}
				});
			} else {
				var rowLabel = Titanium.UI.createLabel({
					left : '12.5%',
					height : 30,
					color : '#363636',
					text : _menu[i],
					font : {
						fontSize : 15,
						fontWeight : 'bold',
						fontFamily : 'Helvetica Neue'

					}
				});
			}
			var row = Titanium.UI.createTableViewRow();
			row.backgroundColor='#ffffff';
			row.height = 45;
			row.add(rowLabel);
			if(ingrs.isAndroid()) {
				var viewL = Ti.UI.createView({
					backgroundImage:_menuImages[j],
					left:15,
					width:18,
					height:15
				});
				row.add(viewL);
				row.viewL = viewL;
			}
			else {			
				row.leftImage = _menuImages[j];
			}
			row.selectedMenu = _menu[i];
			dataSource.push(row);

		};

		/* Table to hold Menu rows */
		var menuTableView = Titanium.UI.createTableView({
			separatorColor:'#e7e7e7',
			data : dataSource,
			backgroundColor : '#e7e7e7'

		});

		if(ingrs.isAndroid()) {
			subNavViewTopLine.top = 20;
			subView.height = 162;
		}

		var view = Titanium.UI.createView({
			left : 0,
			right : 0,
			height : 75,
			bottom : 75
		});
		var subNavViewBottomLine = Titanium.UI.createView({
			top : 0,
			height : 7,
			backgroundColor : '#ff6900'
		});

		view.add(subNavViewBottomLine);

		menuTableView.headerView = subView;

		menuTableView.footerView = view;

		container.add(menuTableView);

		/*
		 * TableView Event Listener.On Selecting a row from the menu,it will be
		 * checked and highlighted
		 */

		menuTableView.addEventListener('click', function(e) {
			var index = e.index, section = e.section, row = e.row, rowdata = e.rowData, colorOff = '#363636', colorOn = '#ff7c00';

			/*
			 * Function that highlights the selected row and
			 * opens the selected menu window after some delay
			 */
			setTimeout(function() {

				for(var i = 0, len = section.rows.length; i < len; i++) {
					section.rows[i].hasCheck = false;
					if(ingrs.isAndroid()) {
						section.rows[i].viewL.backgroundImage = _menuImages[i];
					}			
					else {
						section.rows[i].leftImage = _menuImages[i];
					}
					section.rows[i].children[0].color = colorOff;
				}
				/* set current check */
				section.rows[index].hasCheck = true;
				if(ingrs.isAndroid()) {
					e.row.viewL.backgroundImage = _menuImagesOn[index];
				}			
				else {
					e.row.leftImage = _menuImagesOn[index];
				}
				e.row.children[0].color = colorOn;
			}, 20);
			if(_module === L('Label_More')) {
				ingrs.more.openChildWin(e.rowData.selectedMenu,menuTableView);
			} else if(_module === L('Label_Investments')) {
				menuTableView.touchEnabled = false;
				ingrs.investments.openChildWin(e.rowData.selectedMenu);
			} else if(_module === L('Label_Balances')) {
				menuTableView.touchEnabled = false;
				ingrs.balances.openChildWin(e.rowData.selectedMenu);
			} else if(_module === L('Label_Contributions')) {
				menuTableView.touchEnabled = false;
				ingrs.contributions.openChildWin(e.rowData.selectedMenu);
			}

			Ti.App.addEventListener('enableTouchOnSubMenuWindow', function(e) {
				menuTableView.touchEnabled = true;
			});
		});
		return container;
	}
	
	ingrs.UI.openWinInLandscape = function() {
		var iOSTopTitle, planText, navTitleText, menuTitle, winLeftNavButton, winRightNavButton, winBackButtonTitle, winBackButtonTitleImage, winTabBarHidden, subHeader, genericTableView, win;
			var datasource, row, explanationText, launchGraphButton;
			iOSTopTitle = ingrs.globalData.company;
			navTitleText='Landscape'
			planText = ingrs.globalData.plan;
			winLeftNavButton = '';
			winRightNavButton = ingrs.UI.NavLogoutButton();
			winBackButtonTitle = 'Back';
			subHeader = ingrs.UI.createDefaultSubHeader(navTitleText, planText, menuTitle);
			datasource = [];
			row = Titanium.UI.createTableViewRow({
				backgroundColor : 'blue'
			});
			datasource.push(row);
			genericTableView = ingrs.UI.buildDefaultTableView(datasource);
			win = ingrs.UI.buildDefaultWindow(genericTableView, iOSTopTitle, winTabBarHidden, winLeftNavButton, winRightNavButton, winBackButtonTitle, winBackButtonTitleImage);
			//win.orientationModes = [Titanium.UI.LANDSCAPE_LEFT, Titanium.UI.LANDSCAPE_RIGHT];
			win.add(subHeader);
			win.addEventListener('close', function(e) {
				Ti.App.fireEvent('setOrientationMode');
			});
			return win;
	}
	
	
	ingrs.UI.balanceByFundWin = function() {
		var iOSTopTitle, planText, navTitleText, menuTitle, winLeftNavButton, winRightNavButton, winBackButtonTitle, winBackButtonTitleImage, winTabBarHidden, subHeader, genericTableView, win;
			var datasource, row, explanationText, launchGraphButton;
			iOSTopTitle = ingrs.globalData.company;
			navTitleText='Landscape'
			planText = ingrs.globalData.plan;
			winLeftNavButton = '';
			winRightNavButton = ingrs.UI.NavLogoutButton();
			winBackButtonTitle = 'Back';
			subHeader = ingrs.UI.createDefaultSubHeader(navTitleText, planText, menuTitle);
			datasource = [];
			var vv = Ti.UI.createView();
			win = ingrs.UI.buildDefaultWindow(vv, iOSTopTitle, winTabBarHidden, winLeftNavButton, winRightNavButton, winBackButtonTitle, winBackButtonTitleImage);
			
			win.add(subHeader);
			return win;
	}
	ingrs.UI.showActivityIndicator = function() {
		activityIndicator = Titanium.UI.createActivityIndicator({
			height : '100%',
			width : '100%',
			message : 'Loading...',
			font : {
				size : 8
			},
			color : 'white',
			style : Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN
		});
		activityIndicator.show();
	}
	ingrs.UI.hideActivityIndicator = function() {
		activityIndicator.hide();
	}
	/*******************************************************************************
	 * Self Calling Function that creates the top Subheader View for all Modules
	 * @param :  _trxTimestamp,_trxConfirmNum,_trxMsg
	 * @returns: subheader Row
	 ******************************************************************************/
	ingrs.UI.createGenericHeaderViewRow = function(_title, _msg) {

		var genericHeaderViewRow = Titanium.UI.createTableViewRow({
			top : 0,
			left : 0,
			right : 0,
			height : 'auto',
			backgroundColor : '#e7e7e7',
			layout : 'vertical',
		});

		/* TITLE text.. big letters */
		var subNavViewSectionTitleLabel = Titanium.UI.createLabel({
			top : 12,
			height : 'auto',
			left : '5%',
			right : '3.1%',
			color : '#363636',
			text : _title,
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 18,
				fontWeight : 'bold'
			}
		});

		/* SUB text, smaller letters */
		var subNavViewSubTextLabel = Titanium.UI.createLabel({
			top : 5,
			bottom : 10,
			height : 'auto',
			left : '5%',
			right : '3.1%',
			color : '#363636',
			text : _msg,
			font : {
				fontfamily : 'Helvetica Neue',
				fontSize : 14,
				fontWeight : 'regular'
			}
		});
		genericHeaderViewRow.add(subNavViewSectionTitleLabel);
		genericHeaderViewRow.add(subNavViewSubTextLabel);

		return genericHeaderViewRow;

	};
	/* end ingrs.UI.createGenericHeaderViewRow */
	ingrs.UI.createOrangeLineRow = function() {
		var orangeLineRow = Titanium.UI.createTableViewRow({
			height : 8,
			backgroundColor : '#ff7c00'
		});
		return orangeLineRow;
	};
	/* end ingrs.UI.createOrangeLineRow */
	
ingrs.UI.cancelTransaction=function(){
	
	var alertDialog = Titanium.UI.createAlertDialog({
	    title:L('Alert_Attention_Title'),
	    message:L('Alert_CancelTransaction_Message'),
	    buttonNames: [L('Alert_Btn_No'),L('Alert_Btn_Yes')],
	    No: 0 /* indexed so 0 = first button in buttonNames array */
	});
	
	alertDialog.show();
	
	alertDialog.addEventListener('click', function(e){
		if (e.index === 1) {
			/*End the Transaction*/
			ingrs.UI.closeAllWindowsTillMain(Ti.API._activeTab, {
				moduleMainWindow : true
			});
			
		}
	});
}
	
	/* Function to open the PDF on Android
	 * Params pdfName - Name of the local file to save pdf contents
	 * 		  _pdfURL - URL to retrieve the pdf data
	 */
	ingrs.util.openPDF = function(_pdfName, _pdfURL,_winTitle,_transWin) {

		if (!Ti.Network.online) {
			var alertDialog = Titanium.UI.createAlertDialog({
				title: L('error_net_unavailable_title'),
				message: L('error_net_unavailable_msg'),
				buttonNames: ['OK']
			});
			alertDialog.show();
			return;
		} else {
			if(ingrs.platform.osname=== "android") {
				ingrs.UI.showActivityIndicator();
				/*Delete Existing PDF file before loading the new*/
				var file = Ti.Filesystem.getFile(Titanium.Filesystem.externalStorageDirectory, _pdfName);				
					if(file.exists()){
						file.deleteFile();
						
					}
				
				var xhr = Ti.Network.createHTTPClient();
				xhr.onload = function() {
					try {
						Ti.API.debug("******Onlioad")
						ingrs.UI.hideActivityIndicator();
						var f = Ti.Filesystem.getFile(Titanium.Filesystem.externalStorageDirectory, _pdfName);
						f.write(this.responseData);
						var intent = Ti.Android.createIntent({
							action : Ti.Android.ACTION_VIEW,
							type : 'application/pdf',
							data : f.getNativePath()
						});
						Ti.Android.currentActivity.startActivity(intent);
					} catch (err) {
						ingrs.UI.hideActivityIndicator();
						var switchProperty = Ti.App.Properties.getString('ANDROID_PDF_DONTASKAGAIN');
						if (switchProperty === 'true') {
							var noPdfReaderDialog = Titanium.UI.createAlertDialog({
								title:L('Alert_Title'),
								message: L('Alert_PDF_Failed'),
								buttonNames: [L('Alert_Button_Label_OK')]
							});
							noPdfReaderDialog.show();
						} else {
							var dialogSubContainerView = Ti.UI.createView({
								width:300, 
								height:180
							});

							// create main message
							var dialogMessageLabel = Ti.UI.createLabel({
								text:L('Alert_No_PDF'),
								top:15,
								left:'5%'
							});

							var askAgainSwitch = Ti.UI.createSwitch({
								style:Titanium.UI.Android.SWITCH_STYLE_CHECKBOX,
								value:false,
								left:'5%',
								width:'auto',
								top:70
							});
							var askAgainLabel = Ti.UI.createLabel({
								text:L('Alert_PDF_Dont_Ask'),
								left:'20%',
								top:80
							});
							askAgainSwitch.addEventListener('change', function() {
								//.value=boolean value of the switch where true is the switch is on and false the switch if off
								Ti.App.Properties.setString('ANDROID_PDF_DONTASKAGAIN', askAgainSwitch.value);
							});
							// add switch and label to wrapper view
							dialogSubContainerView.add(dialogMessageLabel);
							dialogSubContainerView.add(askAgainSwitch);
							dialogSubContainerView.add(askAgainLabel);
							//dialogSubContainerView.add(askAgainView);

							var noPdfReaderDialog = Titanium.UI.createOptionDialog({
								title:L('Alert_Title'),
								options:null,
								buttonNames:['Yes','No'],
								cancel:0,
								androidView:dialogSubContainerView
							});
							noPdfReaderDialog.show();

							// add event listener
							noPdfReaderDialog.addEventListener('click', function(e) {
								if (e.index == 0) {
									Ti.Platform.openURL('http://search?q=pdf');
								}
							});
						}
					}
				};
				xhr.onerror = function(e) {
					ingrs.UI.hideActivityIndicator();
					
				};
				xhr.open("GET", _pdfURL);
				xhr.send();

			} else {

				var iOSTopTitle,planText,navTitleText,menuTitle,winLeftNavButton,winRightNavButton,winBackButtonTitle,winBackButtonTitleImage,winTabBarHidden,title,win;

				iOSTopTitle = ingrs.globalData.company;
				planText = ingrs.globalData.plan;
				menuTitle = '';
				winLeftNavButton = '';
				winRightNavButton ='';
				winBackButtonTitle = L('Label_Back_Button');
				winBackButtonTitleImage = '';
				winTabBarHidden=false;

				var webview = Ti.UI.createWebView();
				webview.url = _pdfURL;
				webview.scalesPageToFit = true;

				win = ingrs.UI.buildDefaultWindow(webview,_winTitle,winTabBarHidden,
				winLeftNavButton,winRightNavButton,winBackButtonTitle,winBackButtonTitleImage,_transWin);
				if(_transWin && _winTitle !== L('Label_More')) {
					win.barColor = '#929292';
				}
				ingrs.UI.openChildWindow(win);

			}
		}
	}

	
})();
/* end */