(function() {
	var data, planTableView, titleName, headerType;
	ingrs.auth.createAcntSummaryWin = function() {

function createAcntSummaryWinInternal() {
		var win = Ti.UI.createWindow({
			backgroundColor : '#e7e7e7',
			fullscreen : false,
			barColor : '#808080',
			
		});
		var logoutButton = Ti.UI.createButton ({
			title:'Logout',
			width:60,
			height:20,
			top:0,
		});
		win.add(logoutButton);
		logoutButton.addEventListener('click',function(e){
			Ti.App.fireEvent('app:eventLogoutClicked');
		});
		
		planDetails = {
			asOfDate : "DEC 7, 2011",
			balance : "$7,786.19",
			planId : 776991,
			planName : "ING AMERICAS SAVINGS PLAN LLC & WWWWWWWWWWWWWWW LLC & ESOP & LTD",
			planType : "SAVINGS"
		}
		titleName = 'ABC';
		headerType = 'I';
		planTableView = getPlanView({
			_planDetails : planDetails,
			homePgMsg : 'XYZ Account Plan',
			partName : "ERIC MONTE-DP"
		});
		
		

		win.add(planTableView);
		return win;
}
if(typeof ingrs.UI.acctSummaryWinHandle === 'undefined' || _refresh) {
			ingrs.UI.acctSummaryWinHandle = createAcntSummaryWinInternal();
			ingrs.homeWindow.push(ingrs.UI.acctSummaryWinHandle);
			return ingrs.UI.acctSummaryWinHandle;
		} else {
			return ingrs.UI.acctSummaryWinHandle;
		}

	};
	function getPlanView(params) {

		var planDetails = params._planDetails;
		var asOfDate, balanceLabel;
		var ds = [];
		var nameRow = Ti.UI.createTableViewRow({
			backgroundColor : '#e7e7e7',
			hasChild : false,
			height : 'auto',
			planName : 'Sridhar Davuluri'
		});
		nameRow.add(getNameView({
			_partName : params.partName
		}));
		
		ds.push(nameRow);
		var borderRow = Ti.UI.createTableViewRow({
			backgroundColor : '#FF7C00',
			hasChild : false,
			height : 7
		});
		ds.push(borderRow);
		for(var i = 0; i < planDetails.length; i++) {

			var planDetailsRow = Ti.UI.createTableViewRow({
				backgroundColor : 'white',
				hasChild : true,
				layout : 'vertical',
				height : 'auto'
			});
			var planName = planDetails[i].planName;
			var planNameLabel = Ti.UI.createLabel({
				text : planName,
				color : '#363636',
				font : {
					fontSize : 14,
					fontWeight : 'bold',
					fontFamily : 'Helvetica Neue'
				},
				top : 10,
				left : '5%',
				right : '5%',
				height : 'auto',
				textid : planDetails[i].planId + "_" + planDetails[i].planType
			});

			planDetailsRow.add(planNameLabel);
			/*Setting Client and Plan Name which will be used across the application and will be tracked based on the plan clicked*/
			planDetailsRow.planName = planDetails[i].planName;
			planDetailsRow.selectedClient = ingrs.auth.selectedClient;

			if( typeof planDetails[i].balance !== 'undefined' && planDetails[i].balance !== null) {
				balanceLabel = Ti.UI.createLabel({
					text : planDetails[i].balance,
					color : '#ff7c00',
					font : {
						fontSize : 18,
						fontWeight : 'bold',
						fontFamily : 'Helvetica Neue'
					},
					top : 5,
					left : '5%',
					width : 'auto',
					height : 'auto'
				})
				planDetailsRow.add(balanceLabel);
			}
			if(planDetails[i].planType === 'SAVINGSSMA') {
				planDetailsRow.add(Ti.UI.createLabel({
					text : 'Balance is included in total plan balance',
					color : '#a1a1a1',
					font : {
						fontSize : 11,
						fontWeight : 'bold',
						fontFamily : 'Helvetica Neue'
					},
					top : 3,
					left : '5%',
					width : 'auto',
					height : 'auto'
				}));
			}

			if( typeof planDetails[i].asOfDate !== 'undefined' && planDetails[i].asOfDate !== null) {
				asOfDate = Ti.UI.createLabel({
					text : "AS OF " + planDetails[i].asOfDate,
					color : '#a1a1a1',
					font : {
						fontSize : 9,
						fontWeight : 'bold',
						fontFamily : 'Helvetica Neue'
					},
					top : 3,
					left : '5%',
					width : 'auto',
					height : 'auto'
				})
				planDetailsRow.add(asOfDate);
			}

			if(planDetails[i].planType === 'SAVINGSSMA' || planDetails[i].planType === 'INGACCESS') {
				planDetailsRow.hasChild = false;
			}

			if(ingrs.isIphone()) {
				if( typeof asOfDate !== 'undefined') {
					asOfDate.bottom = 10
				} else if( typeof balanceLabel !== 'undefined') {
					balanceLabel.bottom = 10;
				} else {
					planNameLabel.bottom = 10;
				}
				ds.push(planDetailsRow);
				var divRow = Ti.UI.createTableViewRow({
					backgroundColor : '#e7e7e7',
					hasChild : false,
					height : 1
				});
				ds.push(divRow);
			} else {
				ds.push(planDetailsRow);
			}
		};

		/* Adding sitemanager message */
		if( typeof params.homePgMsg !== 'undefined' && params.homePgMsg !== null) {
			var messageRow = Ti.UI.createTableViewRow({
				backgroundColor : 'white',
				hasChild : false,
				height : 'auto'
			});
			messageRow.add(Ti.UI.createLabel({
				text : params.homePgMsg,
				color : '#363636',
				font : {
					fontSize : 14,
					fontFamily : 'Helvetica Neue'
				},
				top : 10,
				bottom : 10,
				left : '5%',
				right : '5%',
				height : 'auto'
			}));
			ds.push(messageRow);
		}
		var tableView = Titanium.UI.createTableView({
			top:40,
			data : ds,
			scrollable : true,
			separatorColor : 'transparent',
			backgroundColor : '#e7e7e7'
		});

		tableView.addEventListener('click', function(e) {
			var data = {
				planId : 8055251,
				cssessionId : 123456,
				planType : 'SAVINGS'
			};
			Ti.App.fireEvent('launchPWEB', data);

		});
		return tableView;
	}

	function getNameView(params) {

		var nameView = Ti.UI.createView({
			top : 0,
			height : 102,
			backgroundImage : '/images/header/1px_gray_sub_header_bg_lrg.png'
		});

		nameView.add(Ti.UI.createImageView({
			image : '/images/header/home_icon.png',
			height : 39,
			width : 44,
			bottom : 0,
			right : '6.25%'
		}));

		nameView.add(Ti.UI.createLabel({
			text : "Welcome,",
			color : '#363636',
			font : {
				fontSize : 18,
				fontWeight : 'bold',
				fontFamily : 'Helvetica Neue'
			},
			top : 10,
			left : '5%',
			width : 'auto',
			height : 'auto'
		}));

		nameView.add(Ti.UI.createLabel({
			text : params._partName,
			color : '#363636',
			font : {
				fontSize : 18,
				fontWeight : 'bold',
				fontFamily : 'Helvetica Neue'
			},
			top : 30,
			left : '5%',
			width : 'auto',
			height : 'auto'
		}));

		return nameView;
	};


	ingrs.auth.setParam = function(_param) {
		data = _param;
	};
	ingrs.auth.getParam = function() {
		return data;
	};
	ingrs.auth.resetHomePageData = function() {
		data = null;
	};
	/* Function invoked on click of footer in the home page */
	ingrs.auth.disclosureDisplay = function() {
		var sections = planTableView.data;
		var section = sections[0];
		var row = section.rows[2];
		var planInfo = row.children[0].textid;
		if( typeof planInfo !== 'undefined') {
			ingrs.globalData.plan = row.planName;
			ingrs.globalData.company = row.selectedClient;
			var prefArray = planInfo.split('_');
			var planId = prefArray[0];
			var planType = prefArray[1];
			var displayOnlyMore = false;

			var data = {
				planId : planId,
				cssessionId : ingrs.auth.cssessionid,
				planType : planType,
				footer : 'Y',
				titleName : titleName,
				headerType : headerType
			};

			if(planType === 'SAVINGS') {
				Ti.API.debug('Launching pweb plan with :' + JSON.stringify(data));
				Ti.App.fireEvent('launchPWEB', data);
			} else if(planType === 'MMPENSION' || planType === 'MMCASH') {
				Ti.API.debug('Launching TRO plan :' + JSON.stringify(data));
				Ti.App.fireEvent('launchTRO', data);
			} else if(planType === 'SAVINGSSMA' || planType === 'INGACCESS') {
				data.planId = 'NOPLAN'
				Ti.API.debug('Launching More window :' + JSON.stringify(data));
				Ti.App.fireEvent('launchMore', data);
			}
		} else {
			var data = {
				cssessionId : ingrs.auth.cssessionid,
				titleName : titleName,
				headerType : headerType,
				planId : 'NOPLAN'
			}
			Ti.API.debug('Launching More window');
			Ti.App.fireEvent('launchMore', data);
		}
	};
})();
