(function(){

	ingrs.auth.createinputSSNWindow = function(param) {
		
		var win =  Ti.UI.createWindow({
			backgroundColor:'#E7E7E7',
			fullscreen:false,
			navBarHidden:true,
			barColor:'#808080',
			layout:'vertical'
		});
		
		var rightBtnClickEVent = function(){
			Ti.App.fireEvent('app:invalidLogin');
		};
		
		var rightBtn = ingrs.auth.title.getRightBtn({_title:'Cancel',_bgi:'/images/btns/grey_btn_on.png',_bgsi:'images/btns/grey_btn_off.png',_clickEvent:rightBtnClickEVent});
		
		win.add(ingrs.auth.getTitleBar({_titleName:'Enhanced Security',_titleBGImage:'/images/header/1px_gray_header_bg.png',_rightBtn:rightBtn}));
		
		var selectText = Ti.UI.createLabel({
			font:{fontSize:16,fontWeight:'bold',fontFamily:'Helvetica Neue'},
			color:'#363636',
			width:'auto',
			text:'Please enter your Social Security Number to continue.',
			height:'auto',
			top:15,
			left:'4.6%',
			borderColor:'transparent'
		});
		
		var secSSNField = Titanium.UI.createTextField({
			color:'#336699',
			height:49,
			top:10,
			right:'3.1%',
			left:'3.1%',
			borderRadius:10,
			font:{fontSize:20,fontFamily:'Helvetica Neue'},
			textAlign:'right',
			backgroundColor: 'white',
			returnKeyType:Titanium.UI.RETURNKEY_DONE,
			keyboardType:Ti.UI.KEYBOARD_NUMBER_PAD,
			hintText:'Required',
			passwordMask:true
			
		});
		
		win.add(selectText);
		win.add(secSSNField);
		
		var btn = Titanium.UI.createButton({
			color:'#fff',
			backgroundImage:'/images/btns/btn_off.png',
			backgroundSelectedImage:'/images/btns/btn_on.png',
			top:40,
			left:'3.1%',
			right:'3.1%',
			height:41,
			font:{fontSize:19,fontWeight:'bold',fontFamily:'Helvetica Neue'},
			title:'Continue'
		});

		win.add(btn);

		
		/* create table view event listener */
		btn.addEventListener('click', function(e)
		{
			//var authData = param.authData;
			
			/*var data = {
				participantId: authData.participantId,
				pin: authData.pin,
				useridtype:authData.useridtype,
				secSSN:secSSNField.value
			};*/
			
			//{"participantId":"010507812","pin":"wq895623","useridtype":"SSN"}
			var data = {
				participantId: "010507812",
				pin: "wq895623",
				useridtype:"SSN",
				secSSN:"010507812"
			};
			ingrs.auth.authenticateUser({data:data});
		//	if(ingrs.auth.validate.validateSSN({_ssn:secSSNField.value})){
				ingrs.auth.authenticateUser({data:data});
		//	}
		});
		
		win.addEventListener('click',function(){
			if (ingrs.isIphone()){
				secSSNField.blur();
			}
		});
		Ti.App.addEventListener('app:invalidLogin', function() {
			win.close();
		});
		
		ingrs.homeWindow.push(win);
		
		return win;
	};

})();

