(function(){
	ingrs.auth.title = {};
	
	ingrs.auth.getTitleBar = function(param){
		
		if(param._titleBGImage != null){
			backgroundImage = param._titleBGImage;
		}else{
			backgroundImage = '/images/header/1px_gray_header_bg.png';
		}
		var titleView = Titanium.UI.createView({
			top:0,
			left:0,
			height:45,
			backgroundImage:backgroundImage
		});
		if (typeof param.leftBtn!=='undefined' && param.leftBtn!==null) {
			titleView.add(param.leftBtn);
		}
		
		var headerType = param._headerType;
		if(typeof headerType !== 'undefined' && headerType !== null && headerType.trim != ''){
			if(headerType === 'I'){
				var titleImage = Ti.UI.createImageView({
					width:94,
					height:24,
					image:'/images/header/ing_logo_header.png',
					anchorPoint:{y:0.5,x:0.5}
				});
				titleView.add(titleImage);
			}else if(headerType === 'C' || headerType === 'P'){
				var titleLabel = Titanium.UI.createLabel({
					color:'#FFFFFF',
					text:param._titleName,
					textAlign:'center',
					top:10,
					height:'auto',
					width:'auto',
					backgroundColor:'transparent',
					font:{fontSize:18,fontWeight:'bold'}
				});
				titleView.add(titleLabel);
			}else {
				//suppress
			}
		}else{
			var titleLabel = Titanium.UI.createLabel({
					color:'#FFFFFF',
					text:param._titleName,
					textAlign:'center',
					top:10,
					height:'auto',
					width:'auto',
					backgroundColor:'transparent',
					font:{fontSize:18,fontWeight:'bold'}
				});
				titleView.add(titleLabel);
		}
		
		if (typeof param._rightBtn!=='undefined' && param._rightBtn!==null) {
			titleView.add(param._rightBtn);
		}
		
		return titleView;
	};
	ingrs.auth.title.getRightBtn = function(param) {
		var rightBtn = Titanium.UI.createButton({
			title:param._title,
			backgroundImage:param._bgi,
			backgroundSelectedImage:param._bgsi,
			width:styles.navRightBtn.width,
			height:styles.navRightBtn.height,
			borderRadius:styles.navRightBtn.borderRadius,
			right:'1.5%',
			color:'#FFFFFF',
			top:8,
			font:styles.navRightBtn.font
			
			});
			
			if (ingrs.isAndroid()) {
		 	rightBtn.width=60;
		 	rightBtn.height=25;
		 	rightBtn.top=8;
		 	rightBtn.bottom=8;
			}
			
		if(param._clickEvent != '') {
			rightBtn.addEventListener('click',param._clickEvent);
		}
			
		return rightBtn;
	};
	
	ingrs.auth.title.getLeftBtn = function(param){
		if(ingrs.isIphone()){
				var btn = Titanium.UI.createButton({
						left:'2%',
						title:param._title,				
		});
		}else{
		var btn = Titanium.UI.createButton({
						backgroundImage:param._bgi,
						backgroundSelectedImage:param._bgsi,
						width:50,
						height:30,
						left:'1.5%',
						color:'#FFFFFF',
						anchorPoint:{y:0.5}
		});
		}
		
	
		if(param._clickEvent !== ''){
			btn.addEventListener('click',param._clickEvent);
		}
		
		return btn;
	};
	
})();