(function(){
	
	ingrs.UI.createAndroidTitleBar=function() {
		
	 	var view = Titanium.UI.createView({
	        layout:'vertical',
	        top:0,
	        left:0,
	        backgroundColor:'#ffffff'
	    });
    
	    var menuBarView = Titanium.UI.createView({
	        top:0,
	        left:0,
	        height:45,
	        width:ingrs.platform.width,
	     	backgroundImage:'/images/header/1px_orange_header_bg.png'
	    });
	    
	    var titleLabel = Titanium.UI.createLabel({
	        text:ingrs.globalData.company,
	        textAlign:'center',
		    top:5,
	        width:'auto',
	        shadowColor:'99582c',
	        color: 'white',
	        shadowOffset:{x:0, y:-1},
	        font:{fontSize:20, fontWeight:'bold'}
	    }); 
	     
		menuBarView.add(titleLabel); 
	 
	    var rightBtn = Ti.UI.createButton ({
		    title:L('Label_Logout_Button'),
			width:55,
			height:30,
			top:5,
			right:5,
			color: 'white',
			backgroundImage:'/images/btns/btn_on.png',
			borderRadius:4,
			font: {
				fontSize:11,
				fontFamily:'Helvetica Neue',
			},
			borderColor: '#B03F02'
		});
		 
		rightBtn.addEventListener('click', function(e){
			Ti.App.fireEvent('app:eventLogoutClicked');
		});
		
		
		menuBarView.add(rightBtn); 
	    /* add all the sub views into the primary view */
	 	view.add(menuBarView);
	 	
     	return view;	
	};
	
	ingrs.UI.createWindowHeaderforAndroid=function(_win,_title, _headerType, _backButtonTitle,_leftNavButton,_rightNavButton,_winTitle,_transactionWin){
		var _greybg=false;
		var INGlogoimage=false;
		
		var menuBarView = Titanium.UI.createView({
	        top:0,
	        left:0,
	        height:45,
	     	//backgroundColor:'#ff7c00',
	     	//backgroundImage:'images/header/1px_orange_header_bg.png'
	    });
	    
	    var titleWrapperView = Titanium.UI.createView({
	        top:0,
	        left:0,
	        height:45,
	        width:'auto'
	    });
	
	    if(_rightNavButton.title === L('Label_Cancel_Button') || _rightNavButton.title === L('Label_Done_Button')){
			menuBarView.backgroundColor = '#E7E7E7';
			menuBarView.backgroundImage = '/images/header/1px_gray_header_bg.png';
			_greybg = true;
	    }
	    
	    /* Replacing the header with the window title if it is a transaction window */
		if(typeof _transactionWin !== 'undefined' && _transactionWin !== null && _transactionWin != ''){
			_headerType = null;
		}
	    // if winTitle is blank then set to ING logo image
	    if(typeof _headerType !== 'undefined' && _headerType !== null && _headerType.trim != ''){
		if (_headerType ==='I') {
			INGlogoimage=true;
			var titleImage=Titanium.UI.createImageView({
				image:'/images/header/ing_logo_header.png',
				height:24,
				width:94
			});
		    titleWrapperView.add(titleImage);
		} else if (_headerType ==='Y'){
			// title text not image. truncate and add "..." if too long, make sure it fits with buttons
			if (_leftNavButton==='' && _backButtonTitle==='' && _rightNavButton===''){
		    	// no buttons, set long title limit
		    	if (_title.length > 31) {
		    		_title=_title.substring(0,30)+'...';
				}
		    } else if (_leftNavButton!=='' || _backButtonTitle!=='' || _rightNavButton==='') {
		    	// have at least 1 button so allow title to be a little longer
		    	if (_title.length > 19) {
		    		_title=_title.substring(0,18)+'...';
				}
		    } else if (_title.length > 15) {
				_title=_title.substring(0,14)+'...';
			}
			
			var titleLabel = Titanium.UI.createLabel({
			    top:5,
			    bottom:5,
		        width:'auto',
		        textAlign:'center',
		        color: 'white',
		        font:{fontSize:18, fontWeight:'bold'},
		        text:_title
		    }); 
		    titleWrapperView.add(titleLabel);
		}
		else{
			//suppress the title
		}
		}else{
			var titleLabel = Titanium.UI.createLabel({
			    top:5,
			    bottom:5,
		        width:'auto',
		        textAlign:'center',
		        color: 'white',
		        font:{fontSize:18, fontWeight:'bold'},
		        text:_winTitle
		    }); 
		    titleWrapperView.add(titleLabel);
		}
		menuBarView.add(titleWrapperView);

	    titleWrapperView.left=15;
	    titleWrapperView.right=15;
	    // add buttons
	    if (_leftNavButton!==''){
	    	menuBarView.add(_leftNavButton);
	    	if (!INGlogoimage)
	    		titleWrapperView.left=60;
	    } else if (_backButtonTitle!=='') {
	    	menuBarView.add(ingrs.UI.AndroidTitlebarBackButton(_win,_backButtonTitle,_greybg));
	    	if (!INGlogoimage)
	    		titleWrapperView.left=60;
	    }
		if (_rightNavButton!=='') {
			menuBarView.add(_rightNavButton);
			if (!INGlogoimage)
				titleWrapperView.right=60;
		}

		return menuBarView;
	};
	
	
})();
