
(function() {
	
	// create empty view for non-modal ios titlebar empty back button
	ingrs.UI.leftNavEmptyView = function() {
	    if (ingrs.isAndroid()) {
	        return '';
	    }else{
	    	var emptyView = Titanium.UI.createView({});
	        return emptyView;
	    }
	};
	
	ingrs.UI.NavLogoutButton=function() {
		
		var logoutButton = Ti.UI.createButton ({
			title:L('Label_Logout_Button'),
			width:styles.navRightBtn.width,
			height:styles.navRightBtn.height,
			top:styles.navRightBtn.top,
			//right:styles.navRightBtn.right,
			font:styles.navRightBtn.font
		});
		
		 if (ingrs.isAndroid()) {
		 	logoutButton.backgroundImage='/images/btns/btn_on.png',
			logoutButton.borderRadius=styles.navRightBtn.borderRadius,
			logoutButton.borderColor=styles.navRightBtn.borderColor
		 	logoutButton.width=60;//'10%';
		 	//logoutButton.height=25;
		 	logoutButton.top=8;
		 	logoutButton.bottom=8;
		 	//logoutButton.left='1.5%';
		 	logoutButton.right='1.5%';
		 	logoutButton.borderRadius=4;
		 	logoutButton.color='#FFFFFF';
		 	logoutButton.font={
				fontSize:12,
				fontfamily:'Helvetica Neue',
				fontWeight:'bold'
			}
		 }
		
		logoutButton.addEventListener('click', function(e){
			Ti.App.fireEvent('app:eventLogoutClicked');
		});
		
		return logoutButton;
		
	}; /* end ingrs.UI.createNavLogoutButton function */
	
	ingrs.UI.NavHomeButton=function() {
		
		var homeButton = Ti.UI.createButton ({
			title:'Home',
			width:styles.navRightBtn.width,
			height:styles.navRightBtn.height,
			top:styles.navRightBtn.top,
			//right:styles.navRightBtn.right,
			//backgroundColor:'#ff7b01',
			backgroundImage:'/images/btns/btn_on.png',
			borderRadius:styles.navRightBtn.borderRadius,
			font: styles.navRightBtn.font,
			borderColor: styles.navRightBtn.borderColor
		});
		
		if (ingrs.isAndroid()) {
		 	homeButton.width=60;
		 	homeButton.height=25;
		 	homeButton.top=8;
		 	homeButton.bottom=8;
		 	homeButton.left='1.5%';
		 	//homeButton.right='1.5%';
		 	homeButton.borderColor='#ff7c00';
		 	homeButton.color='#FFFFFF';
		 	homeButton.font={
				fontSize:12,
				fontfamily:'Helvetica Neue',
				fontWeight:'bold'
			}
		 }
		
		homeButton.addEventListener('click', function(e)
		{
			Ti.App.fireEvent('eventHomeButtonClicked', {});
		});
		
		return homeButton;
		
	}; /* end ingrs.UI.createNavHomeButton function */
	
	ingrs.UI.NavCancelButton=function() {
		if(ingrs.isIphone()){
			var cancelBtn = Ti.UI.createButton({
	    
			title:L('Label_Cancel_Button'),
			
		});
		}else{
		
		var cancelBtn = Ti.UI.createButton({
	    	width:50,
			height:30,
			top:5,
			right:'1.5%',
			title:L('Label_Cancel_Button'),
			//backgroundColor:'#a1a1a1',
			backgroundImage:'/images/btns/grey_btn_on.png',
			font:styles.navRightBtn.font
		});
		
		if (ingrs.isAndroid()) {
		 	cancelBtn.width=60;
		 	cancelBtn.height=25;
		 	cancelBtn.top=8;
		 	cancelBtn.bottom=8;
		 	//homeButton.left='1.5%';
		 	cancelBtn.right='1.5%';
		 	cancelBtn.backgroundImage='/images/btns/grey_btn_on.png';
		 	cancelBtn.color='#FFFFFF';
		 	cancelBtn.font={
				fontSize:12,
				fontfamily:'Helvetica Neue',
				fontWeight:'bold'
			}
		}
		}
		return cancelBtn;
		
	}; /* end ingrs.UI.NavCancelButton function */
	
	ingrs.UI.NavSettingsButton=function() {
		
		var settingsBtn = Ti.UI.createButton({
	    	width:60,
			height:30,
			top:5,
			left:'1.5%',
			title:L('Label_Settings_Button'),
			//backgroundColor:'#a1a1a1',
			backgroundImage:'/images/btns/btn_on.png',
			font:styles.navRightBtn.font
		});
		
		if (ingrs.isAndroid()) {
		 	settingsBtn.width=72;
		 	settingsBtn.height=25;
		 	settingsBtn.top=8;
		 	settingsBtn.bottom=8;
		 	//homeButton.left='1.5%';
		 	settingsBtn.left='1.5%';
		 	settingsBtn.backgroundImage='/images/btns/btn_on.png';
		 	settingsBtn.color='#FFFFFF';
		 	settingsBtn.font={
				fontSize:12,
				fontfamily:'Helvetica Neue',
				fontWeight:'bold'
			}
		}
		
		return settingsBtn;
		
	}; /* end ingrs.UI.NavSettingsButton function */
	
	ingrs.UI.NavDoneButton=function(_args) {
		
		var doneBtn = Ti.UI.createButton({
	    	width:50,
			height:30,
			top:5,
			right:5,
			title:L('Label_Done_Button'),
			//backgroundColor:'#ff7c00'
			backgroundImage:'/images/btns/btn_on.png',
			font:styles.navRightBtn.font
		});
		
		if (ingrs.isAndroid()) {
		 	doneBtn.width=60;
		 	doneBtn.height=25;
		 	doneBtn.top=8;
		 	doneBtn.bottom=8;
		 	//homeButton.left='1.5%';
		 	doneBtn.right='1.5%';
		 	doneBtn.backgroundImage='/images/btns/btn_on.png';
		 	doneBtn.color='#FFFFFF';
		 	doneBtn.font={
				fontSize:12,
				fontfamily:'Helvetica Neue',
				fontWeight:'bold'
			}
		}
		
		/*
		if(typeof _args !== 'undefined' && _args !== null)  {
			if (_args==='orange') {
				doneBtn.backgroundImage = 'images/btns/btn_on.png';
			}
		}*/
		
		return doneBtn;
		
	}; // end ingrs.UI.NavDoneButton
	
	ingrs.UI.NavCloseButton=function(_args) {
		
		var closeBtn = Ti.UI.createButton({
	    	width:50,
			height:30,
			top:5,
			right:5,
			title:L('Label_Close_Button'),
			//backgroundColor:'#ff7c00'
			backgroundImage:'images/btns/grey_btn_on.png',
			font:styles.navRightBtn.font
		});
		
		if (ingrs.isAndroid()) {
		 	closeBtn.width=60;
		 	closeBtn.height=25;
		 	closeBtn.top=8;
		 	closeBtn.bottom=8;
		 	//homeButton.left='1.5%';
		 	closeBtn.right='1.5%';
		 	closeBtn.backgroundImage='/images/btns/grey_btn_on.png';
		 	closeBtn.color='#FFFFFF';
		 	closeBtn.font={
				fontSize:12,
				fontfamily:'Helvetica Neue',
				fontWeight:'bold'
			}
		}
		
		/*
		if(typeof _args !== 'undefined' && _args !== null)  {
			if (_args==='orange') {
				doneBtn.backgroundImage = 'images/btns/btn_on.png';
			}
		}*/
		
		return closeBtn;
		
	}; // end ingrs.UI.NavCloseButton
	
	ingrs.UI.AndroidTitlebarBackButton=function(_win,_text,_greybg) {
		
		var backBtn = Ti.UI.createButton({
	    	width:55,
			height:25,
			top:8,
			bottom:8,
			left:'1.5%',
			title:_text,
			backgroundColor:'#ff7c00',
			backgroundImage:'/images/btns/btn_on.png',
			color:'#FFFFFF',
			font:{
				fontSize:12,
				fontfamily:'Helvetica Neue',
				fontWeight:'bold'
			}
		});
		if(_greybg){
			backBtn.backgroundColor = '#a1a1a1';
			backBtn.backgroundImage = '/images/btns/grey_btn_on.png';
		}
		
		backBtn.addEventListener('click', function(e) {
			_win.close();
			Ti.App.fireEvent('closeFull',{source:_win});
		});
		
		return backBtn;
		
	}; /* end ingrs.UI.NavCancelButton function */
	
})();