(function() {

	ingrs = {};
	ingrs.UI = {};
	/*Namespace for Balance Summary Module*/
	ingrs.util= {};
	ingrs.balances= {};
	ingrs.contributions= {};
	ingrs.android= {};
	ingrs.common= {};
	ingrs.investments= {};
	ingrs.more= {};
	ingrs.inv= {};
	ingrs.fundTransfer= {};
	ingrs.platform = {
		id : Titanium.Platform.id,
		macaddress : Titanium.Platform.macaddress,
		model : Titanium.Platform.model,
		name : Titanium.Platform.name,
		version : Titanium.Platform.version,
		osname : Titanium.Platform.osname,
		width : Ti.Platform.displayCaps.platformWidth,
		height : Ti.Platform.displayCaps.platformHeight
	};

	/* styles */
	Ti.include('/common/styles.js');

	/* data sets */
	Ti.include('/common/dataGlobal.js');

	/* common files */
	Ti.include('/common/ui.js');

	Ti.include('/common/buttons.js');
	Ti.include('/common/subheader.js');
	Ti.include('/common/uibuilder.js');
	Ti.include('/common/androidtitlebar.js');
	Ti.include('/common/tabhandler.js');

	/* login */
	Ti.include('/login/login_ui.js');
	Ti.include('/login/login_title.js');

	Ti.include('/login/login.js');
	Ti.include('/login/loginPreferences.js');
	Ti.include('/login/inputSSN.js');
	Ti.include('/login/accntsSummary.js');

	Ti.include('/balances/balancesWindowMain.js');
	Ti.include('/balances/balancesTableViewDS.js');
	Ti.include('/balances/balancesFunctions.js');



	/* title bar for droid */ /* TODO: move it to more appropriate file like ui.js */
	ingrs.android.droidTitleBarHeight = 0;
	if (ingrs.platform.osname === "android") {
		ingrs.android.droidTitleBarHeight = 45;
	}
var iPhone = (ingrs.platform.name==='iPhone OS');
	var android = (ingrs.platform.name==='android');
	ingrs.isIphone = function() {
		return iPhone;
	};
	ingrs.isAndroid = function() {
		return android;
	};
})();