(function() {

	ingrs.auth.loginPref = {};

	var flexSpace = Titanium.UI.createButton({
		systemButton:Titanium.UI.iPhone.SystemButton.FLEXIBLE_SPACE
	});

	var data = [{
		loginDisplay:'SSN',
		prefDisplay:'Social Security Number',
		keyboard:Ti.UI.KEYBOARD_NUMBER_PAD,
		keyboardToolbar:[flexSpace,flexSpace,ingrs.auth.ui.done],
		keyboardToolbarColor:'#999',
		keyboardToolbarHeight:40,
		serverValue:'SSN',
		mask:true,
		encrypt:true
	},{
		loginDisplay:'Employee ID',
		prefDisplay:'Employee ID',
		keyboard:Ti.UI.KEYBOARD_NUMBER_PAD,
		keyboardToolbar:[flexSpace,flexSpace,ingrs.auth.ui.done],
		keyboardToolbarColor:'#999',
		keyboardToolbarHeight:40,
		serverValue:'EID',
		mask:true,
		encrypt:false
	},{
		loginDisplay:'Username',
		prefDisplay:'Username',
		keyboard:Ti.UI.KEYBOARD_DEFAULT,
		serverValue:'UNAME',
		mask:true,
		encrypt:false
	}];

	ingrs.auth.loginPref.getLoginPref = function() {
		return data;
	};
	ingrs.auth.loginPref.createWindow = function(currentPref,/*update pref Func*/ updatePref) {

		var data =ingrs.auth.loginPref.getLoginPref();
		var tableview = Ti.UI.createView({
			height:132,
			right:'3.1%',
			left:'3.1%',
			scrollable:false,
			backgroundColor:'white',
			top:60,
			borderRadius:10,
			borderWidth:1,
			borderColor:'#808080',
			layout:'vertical'
		});
		var prefdescLabel =  Ti.UI.createLabel({
			left:'5%',
			font: {
				fontSize:14,
				fontFamily:'Helvetica Neue'
			},
			color:'#363636',
			top:210,
			right:'3%',
			//width:'90%',
			text:L('Label_LoginPref_Msg'),
			height:'auto',
			borderColor:'transparent'
		});
		if(ingrs.isAndroid()) {
			//prefdescLabel.width='90%';
			var leftBtnClickEvent = function() {
				prefWin.close();
			};
			var leftBtn = ingrs.auth.title.getLeftBtn({
				_title:L('Label_Back_Button'),
				_bgi:'/images/btns/btn_grey_back.png',
				_bgsi:'/images/btns/btn_grey_back.png',
				_clickEvent:leftBtnClickEvent
			});
			var prefWin =  Ti.UI.createWindow({
			fullscreen:false,
			barColor:'#808080',
			backgroundColor:'#E7E7E7',
			navBarHidden:true
			});
			prefWin.add(ingrs.auth.getTitleBar({
				_titleName:L('Login_Title'),
				_titleBGImage:'/images/header/1px_gray_header_bg.png',
			}));
			prefWin.add(tableview);
			prefWin.add(prefdescLabel);
		} else {
			tableview.top=20;
			prefdescLabel.top=10;
			var prefWin = Ti.UI.createWindow({
				backgroundColor:'#E7E7E7',
				title:L('Login_Title'),
				layout:'vertical',
				barColor:'#808080',
				navBarHidden: false,
				modal:true,
			});

			prefWin.add(tableview);
			prefWin.add(prefdescLabel);
			/*	var leftBtn = Titanium.UI.createButton({
			 title:L('Label_Back_Button'),
			 });
			 prefWin= Ti.UI.createWindow({
			 navBarHidden:true,
			 });

			 var modalWin= Ti.UI.createWindow({
			 backgroundColor:'#E7E7E7',
			 //	leftNavButton:leftBtn,
			 barColor:'#808080',
			 title:L('Login_Title'),
			 layout:'vertical',
			 backButtonTitle:'Back'
			 });

			 var nav=Ti.UI.iPhone.createNavigationGroup({
			 window:modalWin
			 })

			 leftBtn.addEventListener('click', function() {
			 prefWin.close();

			 });
			 modalWin.add(tableview);
			 modalWin.add(prefdescLabel);
			 prefWin.add(nav);*/

		}

		// create table view

		/*	var tableview = ingrs.auth.ui.createCustomTableView({
		 top:60,
		 height:132
		 });*/

		/*	if(ingrs.isIphone()) {
		 var currentOrientation=ingrs.UI.getOrientation(Titanium.Gesture.orientation);
		 if(currentOrientation='portrait') {
		 tableview.top=10;
		 prefdescLabel.top=150;
		 }
		 }

		 var winOrientation = 0;
		 Ti.Gesture.addEventListener('orientationchange', function(e) {
		 var orientatioNumber = Ti.Gesture.orientation.toString();

		 if(ingrs.isIphone()) {
		 if(e.source.isPortrait()) {
		 tableview.top=55;
		 myorientation = '1';
		 prefdescLabel.top=195;
		 } else if(e.source.isLandscape()) {
		 tableview.top=45;
		 prefdescLabel.top=185;
		 myorientation = '2';
		 } else if((winOrientation == '1' || winOrientation =='2') && orientatioNumber == '5') {

		 } else if(winOrientation == '2' && orientatioNumber == '5') {

		 } else {
		 tableview.top=55;
		 prefdescLabel.top=195;
		 }
		 }
		 });*/

		for (var i=0;i<data.length;i++) {

			var showEndLine = true;
			if(i===data.length-1) {
				showEndLine = false;
			}

			var row = ingrs.auth.ui.createCustomRowView({
				_showEndLine:showEndLine
			});

			var l = Ti.UI.createLabel({
				left:'3.1%',
				right:0,
				font: {
					fontSize:17,
					fontWeight:'bold'
				},
				color:'#000000',
				height:44,
				text:data[i].prefDisplay
			});
			if(currentPref === data[i].loginDisplay) {
				var img = Ti.UI.createImageView({
					image:'/images/icons/icon_blu_check.png',
					anchorPoint: {
						y:0.5
					},
					height:13,
					width:13,
					right:10
				});
				row.add(img);
				l.color = '#335085';
			}

			row.add(l);
			tableview.add(row);
		}

		// create table view event listener
		tableview.addEventListener('click', function(e) {
			for (var i=0;i<data.length;i++) {
				if(e.source.text === data[i].prefDisplay) {
					updatePref(data[i]);
					break;
				}
			}
			/*For iOS close the navigation group .For Android simply close the window*/
			if(ingrs.isIphone()) {
				Ti.App.fireEvent('closeNavigationGroup');
			} else {
				prefWin.close();
			}

		});
	
		
		return prefWin;
	};

	ingrs.auth.loginPref.populateSavedPref = function(prefRowL2, userTypeValue,
			userTypeMask, rememberSwitch) {

		try {
			var storedPref = Ti.App.Properties.getString('LOGIN_PREFERENCE');
			if (storedPref !== null && storedPref !== '') {
				var loginPref = JSON.parse(storedPref);
				rememberSwitch.value = loginPref.isSavePref;
				if (loginPref.isSavePref === true) {
					prefRowL2.text = loginPref.loginType;
					userTypeValue.hintText = loginPref.loginType;
					var len = data.length;
					for ( var i = 0; i < data.length; i++) {
						if (loginPref.loginType === data[i].loginDisplay) {
							prefRowL2.textid = data[i].serverValue;
							userTypeValue.keyboardType = data[i].keyboard;
							userTypeValue.passwordMask = data[i].mask;
							if (data[i].encrypt === true) {
								/*
								 * remove-key this should never get executed
								 * since we disable the control to encrypt data
								 */
								/*
								 * userTypeValue.value =
								 * ingrs.util.decrypt(loginPref.value);
								 */
								rememberSwitch.value = false;
								rememberSwitch.enabled = false;
							} else {
								userTypeValue.value = loginPref.value;
								rememberSwitch.enabled = true;
							}
							if (data[i].serverValue!=='SSN') {
								var tmp = userTypeValue.value;
								if (tmp!==null && tmp.length>4) {
									tmp = tmp.substring(0,4);
								}
								userTypeMask.text = tmp;
							}
							/* removing the toolbar if the login type is Username */
							if(data[i].serverValue === 'Username') {
								userTypeValue.keyboardToolbar = null;
								userTypeValue.keyboardToolbarColor = null;
								userTypeValue.keyboardToolbarHeight = null;
							} else {
								userTypeValue.keyboardToolbar = data[i].keyboardToolbar;
								userTypeValue.keyboardToolbarColor = data[i].keyboardToolbarColor;
								userTypeValue.keyboardToolbarHeight = data[i].keyboardToolbarHeight;
							}
							break;
						}
					}
				}
			}
		} catch(e) {
			Ti.API.error('LOGIN_PREFERENCE removed - ' + e);
			Ti.App.Properties.removeProperty('LOGIN_PREFERENCE');
		}
	};
	ingrs.auth.loginPref.storeLoginPref = function(_param) {
		if (_param!==null && _param.isSavePref) {
			var isEncrypt = false;
			var len = data.length;
			for ( var i = 0; i < len; i++) {
				if (_param.loginType === data[i].loginDisplay && data[i].encrypt) {
					isEncrypt = true;
					break;
				}
			}
			var store = true;
			if (isEncrypt) {
				store = false;
				/* remove-key
				 * this should never get executed since we disable the control to encrypt data
				 */
				/*var secret = ingrs.util.encrypt(_param.value);
				 if (secret!==null || secret!=='') {
				 _param.value = secret;
				 } else {
				 store = false;
				 }*/
			}
			if (store) {
				Ti.API.debug('string to save::' + JSON.stringify(_param));
				Ti.App.Properties.setString('LOGIN_PREFERENCE', JSON.stringify(_param));
			}
		} else {
			var pref = {
				isSavePref:false
			};
			Ti.App.Properties.setString('LOGIN_PREFERENCE', JSON.stringify(pref));
		}
	};
})();